Subject: Re: [PATCH] regex: not all macOS platforms seem to have REG_ENHANCED

From: Junio C Hamano <[email-masked]>
Date: Thu, 19 Mar 2026 18:30:51 -0700

René Scharfe <[email-masked]> writes:

> On 3/19/26 11:37 PM, Junio C Hamano wrote:
>> Earlier, 54463d32 (use enhanced basic regular expressions on macOS,
>> 2023-01-08) started to use the REG_ENHANCED option when ERE is not
>> in use on macOS.  The build seems to have started failing on
>> macos-14 CI jobs at GitHub, however, as apparently not all the macOS
>> platforms have this flag defined.
>
> Interesting.  https://en.wikipedia.org/wiki/MacOS_version_history says
> macOS 14 (Sonoma) was released 2023-09-26, i.e. more than eight months
> after the patch.  And the oldest regex(3) man page I could find also
> mentions REG_ENHANCED:
>
> https://man.freebsd.org/cgi/man.cgi?query=regex&apropos=0&sektion=0&manpath=macOS+10.12.0&format=html

Well, I have no idea where this breakage came from; it suddenly
started in today's pushout, and I do not think we have made any
changes on our end to cause it.

E.g.,
https://github.com/git/git/actions/runs/23315793655/job/67814861386#step:4:301

In any case, in the same CI run, a few other jobs on osx- that uses
the same macos-14 image seem to be passing, so I am reasonably sure
that the posted patch is a *bad* idea.  Instead of forcing us to
figure out why REG_ENHANCED is missing, it would just hide the
problem under the rug, possibly breaking a random regex tests that
happen to depend on the "enhanced mode" working. X-<.